## ros-indigo-teb-local-planner 0.4.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(teb_local_planner)

# Set to Release in order to speed up the program significantly
set(CMAKE_BUILD_TYPE Release) #None, Debug, Release, RelWithDebInfo, MinSizeRel

## Find catkin macros and libraries
find_package(catkin REQUIRED COMPONENTS
  base_local_planner
  costmap_2d
  costmap_converter
  cmake_modules
  dynamic_reconfigure
  geometry_msgs
  interactive_markers
  message_generation
  nav_core
  nav_msgs
  roscpp
  std_msgs
  pluginlib
  tf
  tf_conversions
  visualization_msgs
)
message(STATUS "System: ${CMAKE_SYSTEM}")
## System dependencies are found with CMake's conventions
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake_modules)
message(STATUS "${CMAKE_MODULE_PATH}")
find_package(Boost REQUIRED COMPONENTS system thread graph)
find_package(SUITESPARSE REQUIRED)
find_package(G2O REQUIRED)

# Eigen3 FindScript Backward compatibility (ubuntu saucy)
# Since FindEigen.cmake is deprecated starting from jade.
if (EXISTS "FindEigen3.cmake")
  find_package(Eigen3 REQUIRED)
  set(Eigen_INCLUDE_DIRS ${Eigen3_INCLUDE_DIRS})
elseif (EXISTS "FindEigen.cmake")
  find_package(Eigen REQUIRED)
elseif (EXISTS "FindEigen.cmake")
  message(WARNING "No findEigen cmake script found. You must provde one of them,
  e.g. by adding it to ${PROJECT_SOURCE_DIR}/cmake_modules.")
endif (EXISTS "FindEigen3.cmake")

set(EXTERNAL_INCLUDE_DIRS ${Eigen_INCLUDE_DIRS} ${SUITESPARSE_INCLUDE_DIRS} ${G2O_INCLUDE_DIR})
set(EXTERNAL_LIBS ${SUITESPARSE_LIBRARIES} ${G2O_LIBRARIES})

## Uncomment this if the package has a setup.py. This macro ensures
## modules and global scripts declared therein get installed
## See http://ros.org/doc/api/catkin/html/user_guide/setup_dot_py.html
# catkin_python_setup()


## C++11 support
## Unfortunately, the 3d-party dependency libg2o requires c++11 starting from ROS Jade.
## Even if the ROS Jade specifications do not want c++11-only packages,
## we cannot compile without c++11 enabled. Another option would be to downgrade  
## libg2o third-party package.
## By now, if you do not want c++11, please refer to the ros indigo version.
IF(NOT MSVC)
  include(CheckCXXCompilerFlag)
  CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
  CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
if(COMPILER_SUPPORTS_CXX11)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
elseif(COMPILER_SUPPORTS_CXX0X)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
else()
  message(STATUS "The compiler ${CMAKE_CXX_COMPILER} has no C++11 support which is required 
  by linked third party packages starting from ROS Jade. Ignore this message for ROS Indigo.")
endif()
endif()

################################################
## Declare ROS messages, services and actions ##
################################################

## To declare and build messages, services or actions from within this
## package, follow these steps:
## * Let MSG_DEP_SET be the set of packages whose message types you use in
##   your messages/services/actions (e.g. std_msgs, actionlib_msgs, ...).
## * In the file package.xml:
##   * add a build_depend and a run_depend tag for each package in MSG_DEP_SET
##   * If MSG_DEP_SET isn't empty the following dependencies might have been
##     pulled in transitively but can be declared for certainty nonetheless:
##     * add a build_depend tag for "message_generation"
##     * add a run_depend tag for "message_runtime"
## * In this file (CMakeLists.txt):
##   * add "message_generation" and every package in MSG_DEP_SET to
##     find_package(catkin REQUIRED COMPONENTS ...)
##   * add "message_runtime" and every package in MSG_DEP_SET to
##     catkin_package(CATKIN_DEPENDS ...)
##   * uncomment the add_*_files sections below as needed
##     and list every .msg/.srv/.action file to be processed
##   * uncomment the generate_messages entry below
##   * add every package in MSG_DEP_SET to generate_messages(DEPENDENCIES ...)

## Generate messages in the 'msg' folder
add_message_files(
  FILES
  ObstacleMsg.msg
  TrajectoryPointMsg.msg
  TrajectoryMsg.msg
  FeedbackMsg.msg
)

## Generate services in the 'srv' folder
# add_service_files(
#   FILES
#   Service1.srv
#   Service2.srv
# )

## Generate actions in the 'action' folder
# add_action_files(
#   FILES
#   Action1.action
#   Action2.action
# )

## Generate added messages and services with any dependencies listed here
generate_messages(
   DEPENDENCIES
   geometry_msgs std_msgs
)

#add dynamic reconfigure api
#find_package(catkin REQUIRED dynamic_reconfigure)
generate_dynamic_reconfigure_options(
  cfg/TebLocalPlannerReconfigure.cfg
)


###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if you package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
  INCLUDE_DIRS include ${EXTERNAL_INCLUDE_DIRS}
  LIBRARIES teb_local_planner ${EXTERNAL_LIBS}
  CATKIN_DEPENDS
	base_local_planner
	costmap_2d
	costmap_converter
	dynamic_reconfigure
	geometry_msgs
	interactive_markers
	message_runtime
	nav_core
	nav_msgs
	pluginlib
	roscpp
	std_msgs
	tf
	tf_conversions
	visualization_msgs
  DEPENDS SUITESPARSE G2O
)

###########
## Build ##
###########

## Specify additional locations of header files
## Your package locations should be listed before other locations
# include_directories(include)
include_directories(
  include
  ${EXTERNAL_INCLUDE_DIRS}
  ${catkin_INCLUDE_DIRS}
)

## Build the teb_local_planner library

add_library(teb_local_planner
   src/timed_elastic_band.cpp
   src/optimal_planner.cpp
   src/obstacles.cpp
   src/visualization.cpp
   src/teb_config.cpp
   src/homotopy_class_planner.cpp
   src/teb_local_planner_ros.cpp
)

# Dynamic reconfigure: make sure configure headers are built before any node using them
add_dependencies(teb_local_planner ${PROJECT_NAME}_gencfg)
# Generate messages before compiling the lib
add_dependencies(teb_local_planner ${PROJECT_NAME}_generate_messages_cpp)

target_link_libraries(teb_local_planner
   ${EXTERNAL_LIBS}
   ${catkin_LIBRARIES}
)



## Build additional executables

add_executable(test_optim_node src/test_optim_node.cpp)

target_link_libraries(test_optim_node
   teb_local_planner
   ${EXTERNAL_LIBS}
   ${catkin_LIBRARIES}
)


#############
## Install ##
#############

# all install targets should use catkin DESTINATION variables
# See http://ros.org/doc/api/catkin/html/adv_user_guide/variables.html

## Mark executable scripts (Python etc.) for installation
## in contrast to setup.py, you can choose the destination
# install(PROGRAMS
#   scripts/my_python_script
#   DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
# )

## Mark executables and/or libraries for installation
install(TARGETS teb_local_planner
   LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
)
install(TARGETS test_optim_node
   RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

## Mark cpp header files for installation
install(DIRECTORY include/${PROJECT_NAME}/
   DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
   #FILES_MATCHING PATTERN "*.h"
   PATTERN ".svn" EXCLUDE
)

## Mark other files for installation (e.g. launch and bag files, etc.)
install(FILES
  teb_local_planner_plugin.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

install(DIRECTORY
  launch cfg scripts
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
  PATTERN ".svn" EXCLUDE
)

#############
## Testing ##
#############

## Add gtest based cpp test target and link libraries
# catkin_add_gtest(${PROJECT_NAME}-test test/test_teb_local_planner.cpp)
# if(TARGET ${PROJECT_NAME}-test)
#   target_link_libraries(${PROJECT_NAME}-test ${PROJECT_NAME})
# endif()

## Add folders to be run by python nosetests
# catkin_add_nosetests(test)

=== debian/changelog ===
ros-indigo-teb-local-planner (0.4.5-0trusty) trusty; urgency=high

  * bugfix in calculateHSignature. Fixes #90 <https://github.com/rst-tu-dortmund/teb_local_planner/issues/90>.
  * fixed centroid computation in a special case of polygon-obstacles
  * Contributors: Christoph Rösmann

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Mon, 13 Aug 2018 22:00:00 -0000

ros-indigo-teb-local-planner (0.4.4-0trusty) trusty; urgency=high

  * Indigo - Kinetic Synchronization: stable features and changes of kinetic (0.6.5/0.6.6) are now available in indigo, e.g.
    * Support for omnidirectional drives
    * Changed inner velocity storage object to geometry_msgs::Twist to also account for the strafing velocity (and later acceleration). This change caused some function prototype modifications.
    * Limiting y-acceleration (strafing acceleration) is now supported if holonomic mode is enabled (vel_max_y > 0)
    * Increased bounds of many variables in dynamic_reconfigure. Resolves #14.
    * HomotopyClassPlanner public interface extended
    * Removed TebConfig dependency in TebVisualization
    * Added intermediate edge layer for unary, binary and multi edges in order to reduce code redundancy.
    * Added an option to compute the actual arc length
    instead of using the Euclidean distance approximation.
    The actual arc length is then used for computing velocities, accelerations
    and the turning radius.
    * New default obstacle association strategy.
    During optimization graph creation, for each pose of the trajectory a
    relevance detection is performed before considering the obstacle
    during optimization. New parameters are introduced. The
    old strategy is kept as 'legacy' strategy (see parameters).
    * update of default parameters for 'costmap_obstacles_behind_robot_dist'
    * Added a warning if the optim footprint + min_obstacle_dist is smaller than the costmap footprint.
    Validation is performed by only comparing the inscribed radii of the footprints.
    * Weight adaptation added for obstacles edges.
    Added parameter 'weight_adapt_factor'.
    Obstacle weights are scaled repeatedly scaled by this factor in each outer TEB iteration.
    Increasing weights iteratively instead of setting a huge value a-priori leads to better numerical conditions.
    * Changed HSignature to a generic equivalence class
    * A new parameter is introduced to prefer the equivalence class of the initial plan
    * Fixed some bugs related to the deletion of candidates and
    for keeping the equivalence class of the initial plan.
    * The trajectory is now initialized backwards for goals close to and behind the robot.
    Parameter 'allow_init_with_backwards_motion' added.
    * Horizon reduction for resolving infeasible trajectories is not activated anymore if the global goal is already selected
    (to avoid oscillations due to changing final orientations)
    * fixed wrong matrix assignment that caused a crash of the planner
    * max_samples parameter added
    * global plan orientations are now taken for TEB initialization if lobal_plan_overwrite_orientation==true
    * Further fixes (thanks to Matthias FÜller and Daniel Neumann for providing patches)

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Thu, 22 Dec 2016 23:00:00 -0000

ros-indigo-teb-local-planner (0.4.3-0trusty) trusty; urgency=high

  * Changed the f0 function for calculating the H-Signature.
    The new one seems to be more robust for a much larger number of obstacles
    after some testing.
  * HomotopyClassPlanner: vertex collision check removed since collisions will be determined in the edge collision check again
  * Fixed distance calculation polygon-to-polygon-obstacle
  * Enlarged upper bounds on goal position and orientation tolerances in *dynamic_reconfigure*. Fixes #13.

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Tue, 16 Aug 2016 22:00:00 -0000

ros-indigo-teb-local-planner (0.4.2-0trusty) trusty; urgency=high

  * Fixed bug causing the goal to disappear in case the robot arrives with non-zero orientation error.
  * Inflation mode for obstacles added (disabled by default).
  * The homotopy class of the global plan is now always forced to be initialized as trajectory.
  * The initial velocity of the robot is now taken into account correctly for
    all candidate trajectories.
  * Removed a check in which the last remaining candidate trajectory was rejected if it was close to an obstacle.
    This fix addresses issue #7 <https://github.com/rst-tu-dortmund/teb_local_planner/issues/7>

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Tue, 14 Jun 2016 22:00:00 -0000

ros-indigo-teb-local-planner (0.4.1-0trusty) trusty; urgency=high

  * Wrong parameter namespace for *costmap_converter* plugins fixed
  * Compiler warnings fixed
  * Workaround for compilation issues that are caused by a bug in boost 1.58
    concerning the graph library (missing move constructor/assignment operator
    in boost source).
  * Using *tf*-listener from *move_base* instead of an isolated one
  * Via-point support improved

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Thu, 19 May 2016 22:00:00 -0000

ros-indigo-teb-local-planner (0.4.0-0trusty) trusty; urgency=high

  * The teb_local_planner supports a path-following mode (w.r.t. the global plan) and via-points now.
    This allows the user to adapt the tradeoff between time-optimality and path-following.
    Check out the new tutorial: "Following the Global Plan (Via-Points)".
  * All external configuration and launch files are removed, since they are part
    of the new teb_local_planner_tutorials package.

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Mon, 18 Apr 2016 22:00:00 -0000

ros-indigo-teb-local-planner (0.3.1-0trusty) trusty; urgency=high

  * Fixed wrong coordinate transformation in 'line' and 'polygon' footprint models.
  * Trajectory selection strategy in case of multiple topologies updated:


=== debian/control ===
Source: ros-indigo-teb-local-planner
Section: misc
Priority: extra
Maintainer: Christoph Rösmann <christoph.roesmann@tu-dortmund.de>
Build-Depends: debhelper (>= 9.0.0), ros-indigo-base-local-planner, ros-indigo-catkin, ros-indigo-cmake-modules, ros-indigo-costmap-2d, ros-indigo-costmap-converter, ros-indigo-dynamic-reconfigure, ros-indigo-geometry-msgs, ros-indigo-interactive-markers, ros-indigo-libg2o, ros-indigo-message-generation, ros-indigo-nav-core, ros-indigo-nav-msgs, ros-indigo-pluginlib, ros-indigo-roscpp, ros-indigo-std-msgs, ros-indigo-tf, ros-indigo-tf-conversions, ros-indigo-visualization-msgs
Homepage: http://wiki.ros.org/teb_local_planner
Standards-Version: 3.9.2

Package: ros-indigo-teb-local-planner
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-indigo-base-local-planner, ros-indigo-costmap-2d, ros-indigo-costmap-converter, ros-indigo-dynamic-reconfigure, ros-indigo-geometry-msgs, ros-indigo-interactive-markers, ros-indigo-libg2o, ros-indigo-message-runtime, ros-indigo-nav-core, ros-indigo-nav-msgs, ros-indigo-pluginlib, ros-indigo-roscpp, ros-indigo-std-msgs, ros-indigo-tf, ros-indigo-tf-conversions, ros-indigo-visualization-msgs
Description: The teb_local_planner package implements a plugin to the base_local_planner of the 2D navigation stack.
 The underlying method called Timed Elastic Band locally optimizes the robot's trajectory with respect to trajectory execution time, separation from obstacles and compliance with kinodynamic constraints at runtime.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-teb-local-planner//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
